#ifndef _compress_H_
#define _compress_H_
/* File compress.ch created by R S Kemmetmueller
   (c) Copyright IBM Corp.  1988-1995.  All rights reserved.

$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $

   compress: a dataobject to store a hidden region of text. */

#include <text.H>
class compress: public text {
  public:
    virtual ATKregistryEntry *ATKregistry();
    static boolean InitializeClass();

    compress();
    virtual ~compress();

    static void Compress(text *txt,long pos,long len);
    static void DecompressAll(text *txt);
    static void DecompressRange(text *txt,long pos,long len);
    static compress *IsThere(text *txt,long pos);

    long GetLineForPos(long pos);
    long GetModified();
    long GetPosForLine(long line);

    virtual void CompressInFront(text *txt,long pos,long len);
    virtual void CompressInBack(text *txt,long pos,long len);
    virtual void DecompressBox(text *txt);
    virtual void PartialDecompress(text *txt,long pos,long len);

    inline long GetLines() { return ((this)->lines); }
    inline void SetLines(long nlines) { ((this)->lines) = (nlines); }

    long lines, loc;
};

#endif /* _compress_H_ */
